## corectrl 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)

project(CoreCtrl LANGUAGES CXX)
set(PROJECT_VERSION 1.3.1)

include(GNUInstallDirs)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# add uninstall target
if(NOT TARGET uninstall)
 configure_file(
   "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
   "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
   IMMEDIATE @ONLY)

 add_custom_target(uninstall
   COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

set(CMAKE_CXX_STANDARD 17)

option (WITH_DEBUG_INFO "Add debug information (to Debug builds)" OFF)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_definitions("-D_DEBUG")
  add_compile_options("-W;-Wall;-Wextra")
  add_compile_options("-Wno-redundant-move;-Wno-sign-compare")

  if (WITH_DEBUG_INFO)
    add_compile_options("-ggdb;-fno-omit-frame-pointer")
  endif()
endif()

find_package(Qt5 5.9 COMPONENTS Core DBus Quick Charts Widgets Network Svg REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(QuaZip REQUIRED)
find_package(Botan REQUIRED)

# Allow pci.ids path customization using -DWITH_PCI_IDS_PATH=<path-to-pci.ids-file> (#136)
set(WITH_PCI_IDS_PATH "/usr/share/hwdata/pci.ids" CACHE FILEPATH "Path to pci.ids file")

add_subdirectory(src)

# Tests
include(CTest)
if(BUILD_TESTING)
  enable_testing()
  add_subdirectory(tests)
endif()

# Icons
string(TOLOWER "${PROJECT_NAME}" ICON_NAME)
foreach(ICON_SIZE 16 22 24 32 48 64 72 96 128 192 256)
    install(
        FILES resources/icon/app_${ICON_SIZE}.svg
        DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/${ICON_SIZE}x${ICON_SIZE}/apps
        RENAME ${ICON_NAME}.svg
    )
endforeach()

# .desktop file
install(
  FILES resources/launcher.desktop
  DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications
  RENAME org.corectrl.corectrl.desktop
)

# AppStream metadata
install(
  FILES resources/org.corectrl.corectrl.appdata.xml
  DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/metainfo
)

=== src/CMakeLists.txt ===
configure_file(config.h.in config.h)

list(APPEND 3RDPARTY_INCLUDE_DIRECTORIES
  ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty
)

list (APPEND 3RDPARTY_COMMON_SRC
  ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/fmt/format.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/easyloggingpp/easylogging++.cc
)

list (APPEND 3RDPARTY_COMMON_DEFINITIONS
  ELPP_THREAD_SAFE
  ELPP_FORCE_USE_STD_THREAD
  ELPP_NO_LOG_TO_FILE
  ELPP_NO_DEFAULT_LOG_FILE
)

list (APPEND 3RDPARTY_SRC
  ${3RDPARTY_COMMON_SRC}
  ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/pugixml/pugixml.cpp
)

list (APPEND 3RDPARTY_DEFINITIONS
  ${3RDPARTY_COMMON_DEFINITIONS}
  UNIT_LIB_DISABLE_IOSTREAM
  DISABLE_PREDEFINED_UNITS
  ENABLE_PREDEFINED_DATA_UNITS
  ENABLE_PREDEFINED_ANGLE_UNITS
  ENABLE_PREDEFINED_TIME_UNITS
  ENABLE_PREDEFINED_ANGULAR_VELOCITY_UNITS
  ENABLE_PREDEFINED_FREQUENCY_UNITS
  ENABLE_PREDEFINED_VOLTAGE_UNITS
  ENABLE_PREDEFINED_POWER_UNITS
  ENABLE_PREDEFINED_TEMPERATURE_UNITS
  ENABLE_PREDEFINED_CONVERT_UNITS
  ENABLE_PREDEFINED_CONCENTRATION_UNITS
)

list(APPEND COMMON_SRC
  ${CMAKE_CURRENT_SOURCE_DIR}/common/fileutils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/common/stringutils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/common/cryptolayer.cpp
)

list(APPEND CORE_SRC
  core/filecache.cpp
  core/profileiconcache.cpp
  core/commandqueue.cpp
  core/sysmodel.cpp
  core/sysexplorer.cpp
  core/sysmodelfactory.cpp
  core/sysmodelsyncer.cpp
  core/session.cpp
  core/profileview.cpp
  core/profilepartview.cpp
  core/profileviewfactory.cpp
  core/profilestorage.cpp
  core/profilexmlparserfactory.cpp
  core/profilepartxmlparserprovider.cpp
  core/profilexmlparser.cpp
  core/profilepartxmlparser.cpp
  core/profilemanager.cpp
  core/profile.cpp
  core/profilepart.cpp
  core/profilepartprovider.cpp
  core/profilefactory.cpp
  core/ccpro/zipdatasource.cpp
  core/ccpro/zipdatasink.cpp
  core/ccpro/ccproparser.cpp
  core/info/cpuinfo.cpp
  core/info/gpuinfo.cpp
  core/info/swinfo.cpp
  core/info/hwiddatasource.cpp
  core/info/hwidtranslator.cpp
  core/components/commonutils.cpp
  core/components/cpuutils.cpp
  core/components/amdutils.cpp
  core/components/gpu.cpp
  core/components/gpuprofilepart.cpp
  core/components/gpuxmlparser.cpp
  core/components/cpu.cpp
  core/components/cpuprofilepart.cpp
  core/components/cpuxmlparser.cpp
  core/components/controls/control.cpp
  core/components/controls/controlmode.cpp
  core/components/controls/controlmodeprofilepart.cpp
  core/components/controls/controlmodexmlparser.cpp
  core/components/controls/controlgroup.cpp
  core/components/controls/controlgroupprofilepart.cpp
  core/components/controls/controlgroupxmlparser.cpp
)

list(APPEND INFO_SRC
  core/info/infoproviderregistry.cpp
  core/info/common/cpuinfolscpu.cpp
  core/info/common/cpuinfoproccpuinfo.cpp
  core/info/common/gpuinfouevent.cpp
  core/info/common/gpuinforevision.cpp
  core/info/common/gpuinfoopengl.cpp
  core/info/common/gpuinfovulkan.cpp
  core/info/common/swinfokernel.cpp
  core/info/common/swinfomesa.cpp
  core/info/amd/gpuinfopm.cpp
  core/info/amd/gpuinfopmoverdrive.cpp
  core/info/amd/gpuinfovbios.cpp
  core/info/amd/gpuinfovram.cpp
  core/info/amd/gpuinfouniqueid.cpp
)

list(APPEND CONTROLS_SRC
  core/components/controls/noop.cpp
  core/components/controls/noopprofilepart.cpp
  core/components/controls/noopxmlparser.cpp
  core/components/controls/gpucontrolprovider.cpp
  core/components/controls/amd/pm/handlers/ppdpmhandler.cpp
  core/components/controls/amd/pm/pmperfmodeprovider.cpp
  core/components/controls/amd/pm/pmperfmodeprofilepart.cpp
  core/components/controls/amd/pm/pmperfmodexmlparser.cpp
  core/components/controls/amd/pm/auto/pmauto.cpp
  core/components/controls/amd/pm/auto/pmautolegacy.cpp
  core/components/controls/amd/pm/auto/pmautor600.cpp
  core/components/controls/amd/pm/auto/pmautoprovider.cpp
  core/components/controls/amd/pm/auto/pmautoprofilepart.cpp
  core/components/controls/amd/pm/auto/pmautoxmlparser.cpp
  core/components/controls/amd/pm/fixed/pmfixed.cpp
  core/components/controls/amd/pm/fixed/pmfixedlegacy.cpp
  core/components/controls/amd/pm/fixed/pmfixedr600.cpp
  core/components/controls/amd/pm/fixed/pmfixedprovider.cpp
  core/components/controls/amd/pm/fixed/pmfixedprofilepart.cpp
  core/components/controls/amd/pm/fixed/pmfixedxmlparser.cpp
  core/components/controls/amd/pm/advanced/pmadvancedprovider.cpp
  core/components/controls/amd/pm/advanced/pmadvancedprofilepart.cpp
  core/components/controls/amd/pm/advanced/pmadvancedxmlparser.cpp
  core/components/controls/amd/pm/advanced/dynamicfreq/pmdynamicfreq.cpp
  core/components/controls/amd/pm/advanced/dynamicfreq/pmdynamicfreqprovider.cpp
  core/components/controls/amd/pm/advanced/dynamicfreq/pmdynamicfreqprofilepart.cpp
  core/components/controls/amd/pm/advanced/dynamicfreq/pmdynamicfreqxmlparser.cpp
  core/components/controls/amd/pm/advanced/fixedfreq/pmfixedfreq.cpp
  core/components/controls/amd/pm/advanced/fixedfreq/pmfixedfreqprovider.cpp
  core/components/controls/amd/pm/advanced/fixedfreq/pmfixedfreqadvprovider.cpp
  core/components/controls/amd/pm/advanced/fixedfreq/pmfixedfreqprofilepart.cpp
  core/components/controls/amd/pm/advanced/fixedfreq/pmfixedfreqxmlparser.cpp
  core/components/controls/amd/pm/advanced/freqmode/pmfreqmodeprovider.cpp
  core/components/controls/amd/pm/advanced/freqmode/pmfreqmodeprofilepart.cpp
  core/components/controls/amd/pm/advanced/freqmode/pmfreqmodexmlparser.cpp
  core/components/controls/amd/pm/advanced/overclock/pmoverclockprovider.cpp
  core/components/controls/amd/pm/advanced/overclock/pmoverclockprofilepart.cpp
  core/components/controls/amd/pm/advanced/overclock/pmoverclockxmlparser.cpp
  core/components/controls/amd/pm/advanced/overclock/freqod/pmfreqod.cpp
  core/components/controls/amd/pm/advanced/overclock/freqod/pmfreqodprovider.cpp
  core/components/controls/amd/pm/advanced/overclock/freqod/pmfreqodprofilepart.cpp
  core/components/controls/amd/pm/advanced/overclock/freqod/pmfreqodxmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/pmoverdrive.cpp
  core/components/controls/amd/pm/advanced/overdrive/pmoverdriveprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/pmoverdriveprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/pmoverdrivexmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqvolt/pmfreqvolt.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqvolt/pmfreqvoltprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqvolt/pmfreqvoltprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqvolt/pmfreqvoltxmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqrange/pmfreqrange.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqrange/pmfreqrangeprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqrange/pmfreqrangeprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqrange/pmfreqrangexmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltcurve/pmvoltcurve.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltcurve/pmvoltcurveprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltcurve/pmvoltcurveprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltcurve/pmvoltcurvexmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltoffset/pmvoltoffset.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltoffset/pmvoltoffsetprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltoffset/pmvoltoffsetprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltoffset/pmvoltoffsetxmlparser.cpp
  core/components/controls/amd/pm/advanced/powerprofile/pmpowerprofile.cpp
  core/components/controls/amd/pm/advanced/powerprofile/pmpowerprofileprovider.cpp
  core/components/controls/amd/pm/advanced/powerprofile/pmpowerprofileprofilepart.cpp
  core/components/controls/amd/pm/advanced/powerprofile/pmpowerprofilexmlparser.cpp
  core/components/controls/amd/pm/advanced/powercap/pmpowercap.cpp
  core/components/controls/amd/pm/advanced/powercap/pmpowercapprovider.cpp
  core/components/controls/amd/pm/advanced/powercap/pmpowercapprofilepart.cpp
  core/components/controls/amd/pm/advanced/powercap/pmpowercapxmlparser.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstate.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstateprovider.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstateprofilepart.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstatexmlparser.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstatemodeprovider.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstatemodeprofilepart.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstatemodexmlparser.cpp
  core/components/controls/amd/fan/fanmodeprovider.cpp
  core/components/controls/amd/fan/fanmodeprofilepart.cpp
  core/components/controls/amd/fan/fanmodexmlparser.cpp
  core/components/controls/amd/fan/auto/fanauto.cpp
  core/components/controls/amd/fan/auto/fanautoprovider.cpp
  core/components/controls/amd/fan/auto/fanautoprofilepart.cpp
  core/components/controls/amd/fan/auto/fanautoxmlparser.cpp
  core/components/controls/amd/fan/fixed/fanfixed.cpp
  core/components/controls/amd/fan/fixed/fanfixedprovider.cpp
  core/components/controls/amd/fan/fixed/fanfixedprofilepart.cpp
  core/components/controls/amd/fan/fixed/fanfixedxmlparser.cpp
  core/components/controls/amd/fan/curve/fancurve.cpp
  core/components/controls/amd/fan/curve/fancurveprovider.cpp
  core/components/controls/amd/fan/curve/fancurveprofilepart.cpp
  core/components/controls/amd/fan/curve/fancurvexmlparser.cpp
  core/components/controls/cpucontrolprovider.cpp
  core/components/controls/cpu/cpufreq.cpp
  core/components/controls/cpu/cpufreqprovider.cpp
  core/components/controls/cpu/cpufreqprofilepart.cpp
  core/components/controls/cpu/cpufreqxmlparser.cpp
  core/components/controls/cpu/cpufreqmodeprovider.cpp
  core/components/controls/cpu/cpufreqmodeprofilepart.cpp
  core/components/controls/cpu/cpufreqmodexmlparser.cpp
)

list(APPEND SENSORS_SRC
  core/components/sensors/graphitemprofilepart.cpp
  core/components/sensors/graphitemxmlparser.cpp
  core/components/sensors/gpusensorprovider.cpp
  core/components/sensors/amd/gpufreq.cpp
  core/components/sensors/amd/memfreq.cpp
  core/components/sensors/amd/gputemp.cpp
  core/components/sensors/amd/junctiontemp.cpp
  core/components/sensors/amd/memorytemp.cpp
  core/components/sensors/amd/gpuvolt.cpp
  core/components/sensors/amd/power.cpp
  core/components/sensors/amd/activity.cpp
  core/components/sensors/amd/memusage.cpp
  core/components/sensors/amd/fanspeedrpm.cpp
  core/components/sensors/amd/fanspeedperc.cpp
  core/components/sensors/cpusensorprovider.cpp
  core/components/sensors/cpu/cpufreqpack.cpp
)

list(APPEND UI_COMPONENTS_SRC
  core/uifactory.cpp
  core/qmlitem.cpp
  core/profilemanagerui.cpp
  core/systeminfoui.cpp
  core/qmlcomponentfactory.cpp
  core/qmlcomponentregistry.cpp
  core/sysmodelqmlitem.cpp
  core/components/gpuqmlitem.cpp
  core/components/cpuqmlitem.cpp
  core/components/sensors/graphitem.cpp
  core/components/sensors/amd/gpufreqgraphitem.cpp
  core/components/sensors/amd/memfreqgraphitem.cpp
  core/components/sensors/amd/gputempgraphitem.cpp
  core/components/sensors/amd/junctiontempgraphitem.cpp
  core/components/sensors/amd/memorytempgraphitem.cpp
  core/components/sensors/amd/gpuvoltgraphitem.cpp
  core/components/sensors/amd/powergraphitem.cpp
  core/components/sensors/amd/activitygraphitem.cpp
  core/components/sensors/amd/memusagegraphitem.cpp
  core/components/sensors/amd/fanspeedrpmgraphitem.cpp
  core/components/sensors/amd/fanspeedpercgraphitem.cpp
  core/components/sensors/cpu/cpufreqpackgraphitem.cpp
  core/components/controls/controlmodeqmlitem.cpp
  core/components/controls/controlgroupqmlitem.cpp
  core/components/controls/noopqmlitem.cpp
  core/components/controls/amd/pm/pmperfmodeqmlitem.cpp

=== tests/CMakeLists.txt ===
option(BUILD_SPLIT_TESTS "Build one test executable per test file" OFF)

# Compile definitions
list(APPEND TESTS_COMPILE_DEFINITIONS
  # https://github.com/catchorg/Catch2/blob/master/docs/configuration.md
  CATCH_CONFIG_FAST_COMPILE

  # https://github.com/zuhd-org/easyloggingpp/blob/master/README.md
  ELPP_DISABLE_LOGS
)

# inlude directories for all tests
list(APPEND TESTS_INCLUDE_DIRECTORIES
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/catch>"
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/trompeloeil>"
  "${PROJECT_SOURCE_DIR}/src/3rdparty"
  "${PROJECT_SOURCE_DIR}/src"
)

# catch main
add_library(catch_main OBJECT "src/main.cpp")
target_include_directories(catch_main PRIVATE ${TESTS_INCLUDE_DIRECTORIES})
target_compile_features(catch_main PRIVATE ${TARGET_COMMON_COMPILE_FEATURES})

# test_* files
file(GLOB test_files "src/test_*.cpp")

# generate test_all executable
add_executable(test_all $<TARGET_OBJECTS:catch_main> ${test_files})
target_include_directories(test_all PRIVATE ${TESTS_INCLUDE_DIRECTORIES})
target_compile_features(test_all PRIVATE ${TARGET_COMMON_COMPILE_FEATURES})
target_compile_definitions(test_all PRIVATE ${TESTS_COMPILE_DEFINITIONS})
target_link_libraries(test_all PRIVATE Qt5::Core corectrl_lib)

add_test(NAME "test_all"
         COMMAND test_all
         WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

# generate one executable per test_* file
if(BUILD_SPLIT_TESTS)
  foreach(file ${test_files})
    get_filename_component(file_name ${file} NAME_WE)
    string(REGEX REPLACE "test_([^$]+)" "test_\\1" test_name ${file_name})

    add_executable(${test_name} $<TARGET_OBJECTS:catch_main> ${file})
    target_include_directories(${test_name} PRIVATE ${TESTS_INCLUDE_DIRECTORIES})
    target_compile_features(${test_name} PRIVATE ${TARGET_COMMON_COMPILE_FEATURES})
    target_compile_definitions(${test_name} PRIVATE ${TESTS_COMPILE_DEFINITIONS})
    target_link_libraries(test_all PRIVATE Qt5::Core corectrl_lib)

    add_test(NAME "${test_name}"
             COMMAND ${test_name}
             WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
  endforeach()
endif()

=== src/helper/CMakeLists.txt ===
find_package(PkgConfig REQUIRED)
find_package(Qt5 5.9 COMPONENTS Core DBus REQUIRED)
find_package(Botan REQUIRED)

set(DBUS_DATADIR_PREFIX_DIR ${CMAKE_INSTALL_FULL_DATADIR})
option(INSTALL_DBUS_FILES_IN_PREFIX "Use installation prefix for D-Bus files" OFF)

# Find dbus
if(NOT INSTALL_DBUS_FILES_IN_PREFIX)
  pkg_check_modules(DBUS REQUIRED dbus-1)
  execute_process(
    COMMAND pkg-config --variable=datadir dbus-1
    RESULT_VARIABLE DBUS_DATADIR_PREFIX_DIR_RESULT
    OUTPUT_VARIABLE DBUS_DATADIR_PREFIX_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  if(NOT DBUS_DATADIR_PREFIX_DIR_RESULT EQUAL "0")
    message(FATAL_ERROR "Failed to retrieve D-Bus `datadir` variable using pkg-config")
  endif()
endif()
message("D-Bus files will be installed into ${DBUS_DATADIR_PREFIX_DIR}/dbus-1")

# Find polkit
pkg_check_modules(POLKIT REQUIRED polkit-gobject-1)
execute_process(
    COMMAND pkg-config --variable=policydir polkit-gobject-1
    RESULT_VARIABLE POLKIT_POLICY_INSTALL_DIR_RESULT
    OUTPUT_VARIABLE POLKIT_POLICY_INSTALL_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
if(NOT POLKIT_POLICY_INSTALL_DIR_RESULT EQUAL "0")
  message(FATAL_ERROR "Failed to retrieve Polkit `policydir` variable using pkg-config")
endif()

list(APPEND PROCESS_MONITOR_SRC
  pmon/processmonitor.cpp
  pmon/procpidsolver.cpp
  pmon/nlprocexecsocket.cpp
  pmon/nlprocexecmonitor.cpp
  pmon/processregistry.cpp
  pmon/appregistry.cpp
  pmon/msgdispatcher.cpp
)

list(APPEND SYSTEM_CONTROL_SRC
  sysctl/sysfswriter.cpp
  sysctl/msgreceiver.cpp
)

set(CMAKE_AUTOMOC ON)
add_executable(corectrl_helperkiller
  helperkiller.cpp
  polkit.cpp
  ${3RDPARTY_COMMON_SRC}
)
set(CMAKE_AUTOMOC OFF)

target_include_directories(corectrl_helperkiller PRIVATE
  ${POLKIT_INCLUDE_DIRS}
  ${3RDPARTY_INCLUDE_DIRECTORIES}
)
target_compile_features(corectrl_helperkiller PRIVATE ${TARGET_COMMON_COMPILE_FEATURES})
target_compile_definitions(corectrl_helperkiller PRIVATE ${3RDPARTY_COMMON_DEFINITIONS})
target_link_libraries(corectrl_helperkiller PRIVATE
  Qt5::Core
  Qt5::DBus
  ${POLKIT_LIBRARIES}
)

configure_file(org.corectrl.helperkiller.service.in org.corectrl.helperkiller.service)
install(TARGETS corectrl_helperkiller DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/corectrl")
install(FILES org.corectrl.helperkiller.conf DESTINATION "${DBUS_DATADIR_PREFIX_DIR}/dbus-1/system.d")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.corectrl.helperkiller.service" DESTINATION "${DBUS_DATADIR_PREFIX_DIR}/dbus-1/system-services")
install(FILES org.corectrl.helperkiller.policy DESTINATION "${POLKIT_POLICY_INSTALL_DIR}")

set(CMAKE_AUTOMOC ON)
add_executable(corectrl_helper
  helper.cpp
  polkit.cpp
  ${3RDPARTY_COMMON_SRC}
  ${COMMON_SRC}
  ${PROCESS_MONITOR_SRC}
  ${SYSTEM_CONTROL_SRC}
)
set(CMAKE_AUTOMOC OFF)

target_include_directories(corectrl_helper PRIVATE
  ${Botan_INCLUDE_DIRS}
  ${POLKIT_INCLUDE_DIRS}
  ${3RDPARTY_INCLUDE_DIRECTORIES}
  ${PROJECT_SOURCE_DIR}/src
)
target_compile_features(corectrl_helper PRIVATE ${TARGET_COMMON_COMPILE_FEATURES})
target_compile_definitions(corectrl_helper PRIVATE ${3RDPARTY_COMMON_DEFINITIONS})
target_link_libraries(corectrl_helper PRIVATE
  Qt5::Core
  Qt5::DBus
  stdc++fs
  pthread
  ${Botan_LIBRARIES}
  ${POLKIT_LIBRARIES}
)

configure_file(org.corectrl.helper.service.in org.corectrl.helper.service)
install(TARGETS corectrl_helper DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/corectrl")
install(FILES org.corectrl.helper.conf DESTINATION "${DBUS_DATADIR_PREFIX_DIR}/dbus-1/system.d")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.corectrl.helper.service" DESTINATION "${DBUS_DATADIR_PREFIX_DIR}/dbus-1/system-services")
install(FILES org.corectrl.helper.policy DESTINATION "${POLKIT_POLICY_INSTALL_DIR}")

## corectrl 1.1.0

=== debian/changelog ===
corectrl (1.1.0-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-19.
  * rules: update with additional dh_auto_configure options.

 -- ”SwampRabbit” <swamprabbit@mxlinux.org>  Sat, 06 Jun 2020 15:54:36 -0400

corectrl (1.0.9-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.
  * commented out 01-qdbuspendingcall.patch to fixed upstream

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Sat, 30 May 2020 00:43:20 -0400

corectrl (1.0.8-1~mx19+1) mx; urgency=medium

  * Initial packaging of new upstream release for MX 19.
  * Added 01-qdbuspendingcall.patch to fix upstream compile error bug #62

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Wed, 18 Mar 2020 00:44:32 -0400

corectrl (1.0.7-1~mx19+1) mx; urgency=medium

  * Initial release for MX-19
  * Debianized package

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Mon, 02 Dec 2019 21:02:05 -0400

=== debian/control ===
Source: corectrl
Section: system
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Juan Palacios <jpalaciosdev@gmail.com>
Build-Depends:
 cmake,
 gcc,
 extra-cmake-modules,
 debhelper (>=11~),
 qttools5-dev,
 qml-module-qtquick2,
 qtdeclarative5-dev,
 libqt5charts5-dev,
 libkf5auth-dev,
 libkf5archive-dev,
 libbotan-2-dev,
 libqca-qt5-2-dev
Standards-Version: 4.1.4
Homepage: https://gitlab.com/corectrl/corectrl

Package: corectrl
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 qml-module-qtquick2,
 qml-module-qtquick-controls2,
 qml-module-qt-labs-platform,
 qml-module-qtcharts,
 qml-module-qtquick-window2,
 qml-module-qtquick-layouts,
 sysvinit-utils,
 util-linux,
 hwdata,
 mesa-utils,
 vulkan-tools
Description: Control your hardware with ease using application profiles
 CoreCtrl is a Free and Open Source GNU/Linux application that
 allows you to control with ease your computer hardware using
 application profiles. It aims to be flexible, comfortable and
 accessible to regular users.

## corectrl 1.3.1

=== debian/changelog ===
corectrl (1.3.1-0~mx21) mx; urgency=medium

  * New upstream release

 -- Timothy E. Harris <maintainer@mxrepo.com>  Sun, 06 Nov 2022 14:48:32 -0500

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: corectrl
 Section: system
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
+Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
 XSBC-Original-Maintainer: Juan Palacios <jpalaciosdev@gmail.com>
 Build-Depends:
  cmake,
@@ -11,11 +11,16 @@
  qttools5-dev,
  qml-module-qtquick2,
  qtdeclarative5-dev,
+ libdbus-1-dev,
+ libdrm-dev,
  libqt5charts5-dev,
  libkf5auth-dev,
  libkf5archive-dev,
  libbotan-2-dev,
- libqca-qt5-2-dev
+ libpolkit-gobject-1-dev,
+ libqca-qt5-2-dev,
+ libqt5svg5-dev,
+ libquazip5-dev
 Standards-Version: 4.1.4
 Homepage: https://gitlab.com/corectrl/corectrl

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## corectrl 1.3.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.3)
 
 project(CoreCtrl LANGUAGES CXX)
-set(PROJECT_VERSION 1.3.1)
+set(PROJECT_VERSION 1.3.3)
 
 include(GNUInstallDirs)
 
@@ -38,6 +38,52 @@
 find_package(QuaZip REQUIRED)
 find_package(Botan REQUIRED)
 
+find_package(fmt 5 QUIET)
+if(NOT fmt_FOUND)
+  message("Using bundled fmt library")
+  list(APPEND 3RDPARTY_INCLUDE_DIRECTORIES ${PROJECT_SOURCE_DIR}/3rdparty/fmt)
+  list(APPEND 3RDPARTY_SRC ${PROJECT_SOURCE_DIR}/3rdparty/fmt/src/format.cc)
+endif()
+
+find_package(pugixml 1.11 QUIET)
+if(NOT pugixml_FOUND)
+  message("Using bundled pugixml library")
+  list(APPEND 3RDPARTY_INCLUDE_DIRECTORIES ${PROJECT_SOURCE_DIR}/3rdparty/pugixml)
+  list(APPEND 3RDPARTY_SRC ${PROJECT_SOURCE_DIR}/3rdparty/pugixml/pugixml.cpp)
+endif()
+
+find_package(units 2.3.1 QUIET)
+if(NOT units_FOUND)
+  message("Using bundled units library")
+  list(APPEND 3RDPARTY_INCLUDE_DIRECTORIES ${PROJECT_SOURCE_DIR}/3rdparty/units)
+endif()
+list(APPEND 3RDPARTY_DEFINITIONS
+  UNIT_LIB_DISABLE_IOSTREAM
+  DISABLE_PREDEFINED_UNITS
+  ENABLE_PREDEFINED_DATA_UNITS
+  ENABLE_PREDEFINED_ANGLE_UNITS
+  ENABLE_PREDEFINED_TIME_UNITS
+  ENABLE_PREDEFINED_ANGULAR_VELOCITY_UNITS
+  ENABLE_PREDEFINED_FREQUENCY_UNITS
+  ENABLE_PREDEFINED_VOLTAGE_UNITS
+  ENABLE_PREDEFINED_POWER_UNITS
+  ENABLE_PREDEFINED_TEMPERATURE_UNITS
+  ENABLE_PREDEFINED_CONVERT_UNITS
+  ENABLE_PREDEFINED_CONCENTRATION_UNITS
+  ELPP_NO_LOG_TO_FILE
+  ELPP_NO_DEFAULT_LOG_FILE
+  ELPP_FORCE_USE_STD_THREAD
+)
+
+find_package(easyloggingpp 9.96.7 QUIET)
+if(NOT easyloggingpp_FOUND)
+  message("Using bundled easyloggingpp library")
+  list(APPEND 3RDPARTY_INCLUDE_DIRECTORIES ${PROJECT_SOURCE_DIR}/3rdparty/easyloggingpp)
+  list(APPEND 3RDPARTY_SRC ${PROJECT_SOURCE_DIR}/3rdparty/easyloggingpp/easylogging++.cc)
+else()
+  list(APPEND 3RDPARTY_SRC ${easyloggingpp_INCLUDE_DIR}/easylogging++.cc)
+endif()
+
 # Allow pci.ids path customization using -DWITH_PCI_IDS_PATH=<path-to-pci.ids-file> (#136)
 set(WITH_PCI_IDS_PATH "/usr/share/hwdata/pci.ids" CACHE FILEPATH "Path to pci.ids file")

=== debian/changelog ===
corectrl (1.3.3+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #986925)

 -- Gürkan Myczko <tar@debian.org>  Mon, 13 Mar 2023 07:20:56 +0100

=== debian/control ===
Source: corectrl
Section: utils
Priority: optional
Maintainer: Gürkan Myczko <tar@debian.org>
Uploaders: Matthias Geiger <matthias.geiger1024@tutanota.de>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 catch2,
 cmake,
 libbotan-2-dev,
 libunits-cpp-dev,
 libeasyloggingpp-dev,
 libtrompeloeil-cpp-dev,
 libquazip1-qt5-dev,
 libqt5charts5-dev,
 libqt5svg5-dev,
 libdbus-1-dev,
 libpolkit-gobject-1-dev,
 libdrm-dev,
 libpugixml-dev,
 libfmt-dev,
 qtdeclarative5-dev,
 qttools5-dev,
 qml-module-qtquick2,
 patchelf
Standards-Version: 4.6.2
Homepage: https://gitlab.com/corectrl/corectrl
Vcs-Browser: https://salsa.debian.org/debian/corectrl
Vcs-Git: https://salsa.debian.org/debian/corectrl.git

Package: corectrl
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 vulkan-tools,
 qml-module-qtcharts,
 qml-module-qtquick-layouts,
 qml-module-qtquick-controls2,
 qml-module-qt-labs-platform,
Description: Control your computer hardware using application profiles
 This aims to be flexible, comfortable and accessible to regular users.

## corectrl 1.3.5

=== debian/changelog ===
corectrl (1.3.5-0mx23) mx; urgency=medium

  * New upstream release
  * Build for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Tue, 04 Apr 2023 00:13:23 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: corectrl
 Section: utils
 Priority: optional
-Maintainer: Gürkan Myczko <tar@debian.org>
+Maintainer: Timothy E. Harris <maintainer@mxrepo.com
+XSBC-Original-Maintainer: Gürkan Myczko <tar@debian.org>
 Uploaders: Matthias Geiger <matthias.geiger1024@tutanota.de>
 Rules-Requires-Root: no
 Build-Depends:

## corectrl 1.3.5+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.3)
 
 project(CoreCtrl LANGUAGES CXX)
-set(PROJECT_VERSION 1.3.3)
+set(PROJECT_VERSION 1.3.5)
 
 include(GNUInstallDirs)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,40 +1,8 @@
 configure_file(config.h.in config.h)
 
-list(APPEND 3RDPARTY_INCLUDE_DIRECTORIES
-  ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty
-)
-
-list (APPEND 3RDPARTY_COMMON_SRC
-  ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/fmt/format.cc
-  ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/easyloggingpp/easylogging++.cc
-)
-
-list (APPEND 3RDPARTY_COMMON_DEFINITIONS
+list(APPEND APP_COMPILE_DEFINITIONS
+  ${3RDPARTY_DEFINITIONS}
   ELPP_THREAD_SAFE
-  ELPP_FORCE_USE_STD_THREAD
-  ELPP_NO_LOG_TO_FILE
-  ELPP_NO_DEFAULT_LOG_FILE
-)
-
-list (APPEND 3RDPARTY_SRC
-  ${3RDPARTY_COMMON_SRC}
-  ${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/pugixml/pugixml.cpp
-)
-
-list (APPEND 3RDPARTY_DEFINITIONS
-  ${3RDPARTY_COMMON_DEFINITIONS}
-  UNIT_LIB_DISABLE_IOSTREAM
-  DISABLE_PREDEFINED_UNITS
-  ENABLE_PREDEFINED_DATA_UNITS
-  ENABLE_PREDEFINED_ANGLE_UNITS
-  ENABLE_PREDEFINED_TIME_UNITS
-  ENABLE_PREDEFINED_ANGULAR_VELOCITY_UNITS
-  ENABLE_PREDEFINED_FREQUENCY_UNITS
-  ENABLE_PREDEFINED_VOLTAGE_UNITS
-  ENABLE_PREDEFINED_POWER_UNITS
-  ENABLE_PREDEFINED_TEMPERATURE_UNITS
-  ENABLE_PREDEFINED_CONVERT_UNITS
-  ENABLE_PREDEFINED_CONCENTRATION_UNITS
 )
 
 list(APPEND COMMON_SRC
@@ -257,3 +225,14 @@
   core/components/controls/controlgroupqmlitem.cpp
   core/components/controls/noopqmlitem.cpp
   core/components/controls/amd/pm/pmperfmodeqmlitem.cpp
+  core/components/controls/amd/pm/auto/pmautoqmlitem.cpp
+  core/components/controls/amd/pm/fixed/pmfixedqmlitem.cpp
+  core/components/controls/amd/pm/advanced/pmadvancedqmlitem.cpp
+  core/components/controls/amd/pm/advanced/dynamicfreq/pmdynamicfreqqmlitem.cpp
+  core/components/controls/amd/pm/advanced/fixedfreq/pmfixedfreqqmlitem.cpp
+  core/components/controls/amd/pm/advanced/freqmode/pmfreqmodeqmlitem.cpp
+  core/components/controls/amd/pm/advanced/overclock/pmoverclockqmlitem.cpp
+  core/components/controls/amd/pm/advanced/overclock/freqod/pmfreqodqmlitem.cpp
+  core/components/controls/amd/pm/advanced/overdrive/pmoverdriveqmlitem.cpp
+  core/components/controls/amd/pm/advanced/overdrive/freqvolt/pmfreqvoltqmlitem.cpp
+  core/components/controls/amd/pm/advanced/overdrive/freqrange/pmfreqrangeqmlitem.cpp

=== src/helper/CMakeLists.txt ===
--- 
+++ 
@@ -32,6 +32,13 @@
   message(FATAL_ERROR "Failed to retrieve Polkit `policydir` variable using pkg-config")
 endif()
 
+list(APPEND HELPER_COMPILE_DEFINITIONS
+  ELPP_THREAD_SAFE
+  ELPP_FORCE_USE_STD_THREAD
+  ELPP_NO_LOG_TO_FILE
+  ELPP_NO_DEFAULT_LOG_FILE
+)
+
 list(APPEND PROCESS_MONITOR_SRC
   pmon/processmonitor.cpp
   pmon/procpidsolver.cpp
@@ -51,7 +58,7 @@
 add_executable(corectrl_helperkiller
   helperkiller.cpp
   polkit.cpp
-  ${3RDPARTY_COMMON_SRC}
+  ${3RDPARTY_SRC}
 )
 set(CMAKE_AUTOMOC OFF)
 
@@ -59,12 +66,12 @@
   ${POLKIT_INCLUDE_DIRS}
   ${3RDPARTY_INCLUDE_DIRECTORIES}
 )
-target_compile_features(corectrl_helperkiller PRIVATE ${TARGET_COMMON_COMPILE_FEATURES})
-target_compile_definitions(corectrl_helperkiller PRIVATE ${3RDPARTY_COMMON_DEFINITIONS})
+target_compile_definitions(corectrl_helperkiller PRIVATE ${HELPER_COMPILE_DEFINITIONS})
 target_link_libraries(corectrl_helperkiller PRIVATE
   Qt5::Core
   Qt5::DBus
   ${POLKIT_LIBRARIES}
+  $<$<BOOL:${fmt_FOUND}>:fmt::fmt>
 )
 
 configure_file(org.corectrl.helperkiller.service.in org.corectrl.helperkiller.service)
@@ -77,7 +84,7 @@
 add_executable(corectrl_helper
   helper.cpp
   polkit.cpp
-  ${3RDPARTY_COMMON_SRC}
+  ${3RDPARTY_SRC}
   ${COMMON_SRC}
   ${PROCESS_MONITOR_SRC}
   ${SYSTEM_CONTROL_SRC}
@@ -90,8 +97,7 @@
   ${3RDPARTY_INCLUDE_DIRECTORIES}
   ${PROJECT_SOURCE_DIR}/src
 )
-target_compile_features(corectrl_helper PRIVATE ${TARGET_COMMON_COMPILE_FEATURES})
-target_compile_definitions(corectrl_helper PRIVATE ${3RDPARTY_COMMON_DEFINITIONS})
+target_compile_definitions(corectrl_helper PRIVATE ${HELPER_COMPILE_DEFINITIONS})
 target_link_libraries(corectrl_helper PRIVATE
   Qt5::Core
   Qt5::DBus
@@ -99,6 +105,7 @@
   pthread
   ${Botan_LIBRARIES}
   ${POLKIT_LIBRARIES}
+  $<$<BOOL:${fmt_FOUND}>:fmt::fmt>
 )
 
 configure_file(org.corectrl.helper.service.in org.corectrl.helper.service)

=== debian/changelog ===
corectrl (1.3.5+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Gürkan Myczko <tar@debian.org>  Sun, 06 Aug 2023 16:13:38 +0200

corectrl (1.3.5+ds-1) unstable; urgency=medium

  * New upstream release
  * Added missing runtime deps in d/control (Closes: #1034272)
  * Updated extended description

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Sun, 09 Apr 2023 09:27:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: corectrl
 Section: utils
 Priority: optional
-Maintainer: Timothy E. Harris <maintainer@mxrepo.com
-XSBC-Original-Maintainer: Gürkan Myczko <tar@debian.org>
+Maintainer: Gürkan Myczko <tar@debian.org>
 Uploaders: Matthias Geiger <matthias.geiger1024@tutanota.de>
 Rules-Requires-Root: no
 Build-Depends:
@@ -40,5 +39,8 @@
  qml-module-qtquick-layouts,
  qml-module-qtquick-controls2,
  qml-module-qt-labs-platform,
+ qml-module-qtquick-window2,
+ qml-module-qtquick2,
 Description: Control your computer hardware using application profiles
+ corectrl allows control of the CPU and AMD GPUs to set custom profiles for applications.
  This aims to be flexible, comfortable and accessible to regular users.

## corectrl 1.3.6+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.3)
 
 project(CoreCtrl LANGUAGES CXX)
-set(PROJECT_VERSION 1.3.5)
+set(PROJECT_VERSION 1.3.6)
 
 include(GNUInstallDirs)

=== debian/changelog ===
corectrl (1.3.6+ds-1) unstable; urgency=medium

  * New upstream release 
  * Sorted d/copyright; added myself for debian/* files
  * Include patch to fix cross building (Closes: #1040535)
  * Remove executable bit for d/watch
  * Updated my mail adress in d/control

 -- Matthias Geiger <werdahias@riseup.net>  Sun, 22 Oct 2023 20:30:51 +0200

=== debian/watch ===
version=4
opts=\
repacksuffix=+ds,\
repack,compression=gz,\
dversionmangle=s/\+(ds)(\.\d+)?$//,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/corectrl-$1\.tar\.gz/ \
   https://gitlab.com/corectrl/corectrl/tags?sort=updated_desc archive/v?\d[\d.]+/corectrl-v?([\d.]+)@ARCHIVE_EXT@

## corectrl 1.3.8+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,9 @@
 cmake_minimum_required(VERSION 3.3)
 
-project(CoreCtrl LANGUAGES CXX)
-set(PROJECT_VERSION 1.3.6)
+project(CoreCtrl)
+set(PROJECT_HOMEPAGE_URL "https://gitlab.com/corectrl/corectrl")
+set(PROJECT_FQDN "org.corectrl.corectrl")
+set(PROJECT_VERSION 1.3.8)
 
 include(GNUInstallDirs)
 
@@ -10,13 +12,13 @@
 
 # add uninstall target
 if(NOT TARGET uninstall)
- configure_file(
-   "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
-   "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
-   IMMEDIATE @ONLY)
+  configure_file(
+    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
+    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
+    IMMEDIATE @ONLY)
 
- add_custom_target(uninstall
-   COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
+  add_custom_target(uninstall
+    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
 endif()
 
 set(CMAKE_CXX_STANDARD 17)
@@ -99,22 +101,24 @@
 # Icons
 string(TOLOWER "${PROJECT_NAME}" ICON_NAME)
 foreach(ICON_SIZE 16 22 24 32 48 64 72 96 128 192 256)
-    install(
-        FILES resources/icon/app_${ICON_SIZE}.svg
-        DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/${ICON_SIZE}x${ICON_SIZE}/apps
-        RENAME ${ICON_NAME}.svg
-    )
+  install(
+    FILES resources/icon/app_${ICON_SIZE}.svg
+    DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/${ICON_SIZE}x${ICON_SIZE}/apps
+    RENAME ${ICON_NAME}.svg
+  )
 endforeach()
 
 # .desktop file
 install(
   FILES resources/launcher.desktop
   DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications
-  RENAME org.corectrl.corectrl.desktop
+  RENAME ${PROJECT_FQDN}.desktop
 )
 
 # AppStream metadata
+configure_file(resources/appdata.xml.in resources/appdata.xml)
 install(
-  FILES resources/org.corectrl.corectrl.appdata.xml
+  FILES ${CMAKE_BINARY_DIR}/resources/appdata.xml
   DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/metainfo
+  RENAME ${PROJECT_FQDN}.appdata.xml
 )

=== src/helper/CMakeLists.txt ===
--- 
+++ 
@@ -23,10 +23,10 @@
 # Find polkit
 pkg_check_modules(POLKIT REQUIRED polkit-gobject-1)
 execute_process(
-    COMMAND pkg-config --variable=policydir polkit-gobject-1
-    RESULT_VARIABLE POLKIT_POLICY_INSTALL_DIR_RESULT
-    OUTPUT_VARIABLE POLKIT_POLICY_INSTALL_DIR
-    OUTPUT_STRIP_TRAILING_WHITESPACE
+  COMMAND pkg-config --variable=policydir polkit-gobject-1
+  RESULT_VARIABLE POLKIT_POLICY_INSTALL_DIR_RESULT
+  OUTPUT_VARIABLE POLKIT_POLICY_INSTALL_DIR
+  OUTPUT_STRIP_TRAILING_WHITESPACE
 )
 if(NOT POLKIT_POLICY_INSTALL_DIR_RESULT EQUAL "0")
   message(FATAL_ERROR "Failed to retrieve Polkit `policydir` variable using pkg-config")
@@ -47,6 +47,7 @@
   pmon/processregistry.cpp
   pmon/appregistry.cpp
   pmon/msgdispatcher.cpp
+  pmon/processeventconnector.c
 )
 
 list(APPEND SYSTEM_CONTROL_SRC

=== debian/changelog ===
corectrl (1.3.8+ds-1) unstable; urgency=medium

  * New upstream release
  * Added d/gbp.conf
  * Refresh cross.patch
  * Updated copyright information for appdata file

 -- Matthias Geiger <werdahias@riseup.net>  Mon, 06 Nov 2023 19:31:20 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Gürkan Myczko <tar@debian.org>
-Uploaders: Matthias Geiger <matthias.geiger1024@tutanota.de>
+Uploaders: Matthias Geiger <werdahias@riseup.net>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),

## corectrl 1.3.11+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 project(CoreCtrl)
 set(PROJECT_HOMEPAGE_URL "https://gitlab.com/corectrl/corectrl")
 set(PROJECT_FQDN "org.corectrl.corectrl")
-set(PROJECT_VERSION 1.3.8)
+set(PROJECT_VERSION 1.3.11)
 
 include(GNUInstallDirs)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,9 @@
 list(APPEND COMMON_SRC
   ${CMAKE_CURRENT_SOURCE_DIR}/common/fileutils.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/common/stringutils.cpp
+)
+
+list(APPEND CRYPTO_SRC
   ${CMAKE_CURRENT_SOURCE_DIR}/common/cryptolayer.cpp
 )
 
@@ -74,6 +77,7 @@
   core/info/amd/gpuinfovbios.cpp
   core/info/amd/gpuinfovram.cpp
   core/info/amd/gpuinfouniqueid.cpp
+  core/info/amd/gpuinfoodfanctrl.cpp
 )
 
 list(APPEND CONTROLS_SRC

=== tests/CMakeLists.txt ===
find_package(Catch2 2.6 QUIET)
if(NOT Catch2_FOUND)
  message("Using bundled Catch2 library")
  list(APPEND TESTS_INCLUDE_DIRECTORIES $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/catch2>)
endif()

find_package(trompeloeil 40 QUIET)
if(NOT trompeloeil_FOUND)
  message("Using bundled trompeloeil library")
  list(APPEND TESTS_INCLUDE_DIRECTORIES $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/trompeloeil>)
endif()

# Compile definitions
list(APPEND TESTS_COMPILE_DEFINITIONS
  ${3RDPARTY_DEFINITIONS}
  CATCH_CONFIG_FAST_COMPILE
  ELPP_DISABLE_LOGS
)

# include directories for all tests
list(APPEND TESTS_INCLUDE_DIRECTORIES
  ${3RDPARTY_INCLUDE_DIRECTORIES}
  ${PROJECT_SOURCE_DIR}/src
)

# catch main
add_library(catch_main OBJECT "src/main.cpp")
target_include_directories(catch_main PRIVATE ${TESTS_INCLUDE_DIRECTORIES})

# test_* files
file(GLOB test_files "src/test_*.cpp")

# generate test_all executable
add_executable(test_all $<TARGET_OBJECTS:catch_main> ${test_files} ${3RDPARTY_SRC})
target_include_directories(test_all PRIVATE ${TESTS_INCLUDE_DIRECTORIES})
target_compile_definitions(test_all PRIVATE ${TESTS_COMPILE_DEFINITIONS})
target_link_libraries(test_all PRIVATE
  corectrl_lib
  Qt5::Core
  $<$<BOOL:${units_FOUND}>:units::units>
  $<$<BOOL:${Catch2_FOUND}>:Catch2::Catch2>
  $<$<BOOL:${trompeloeil_FOUND}>:trompeloeil::trompeloeil>
)

add_test(NAME "test_all"
         COMMAND test_all
         WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== src/helper/CMakeLists.txt ===
--- 
+++ 
@@ -87,6 +87,7 @@
   polkit.cpp
   ${3RDPARTY_SRC}
   ${COMMON_SRC}
+  ${CRYPTO_SRC}
   ${PROCESS_MONITOR_SRC}
   ${SYSTEM_CONTROL_SRC}
 )

=== debian/changelog ===
corectrl (1.3.11+ds-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:41:19 +1100

corectrl (1.3.11+ds-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@riseup.net>  Wed, 13 Mar 2024 19:54:21 +0100

corectrl (1.3.10+ds-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@riseup.net>  Mon, 12 Feb 2024 23:36:24 +0100

corectrl (1.3.9+ds-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@riseup.net>  Wed, 17 Jan 2024 22:25:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: corectrl
 Section: utils
 Priority: optional
-Maintainer: Gürkan Myczko <tar@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Gürkan Myczko <tar@debian.org>
 Uploaders: Matthias Geiger <werdahias@riseup.net>
 Rules-Requires-Root: no
 Build-Depends:

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
include /usr/share/dpkg/architecture.mk
DEBARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCatch2_DIR=/usr/lib/cmake/Catch2 \
	-DBUILD_TESTING=OFF
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)


override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/corectrl/usr/lib/$(DEBARCH)/corectrl/
	mv debian/corectrl/usr/lib/$(DEBARCH)/libcorectrl.so debian/corectrl/usr/lib/$(DEBARCH)/corectrl/

execute_after_dh_install:
	patchelf --replace-needed libcorectrl.so /usr/lib/$(DEBARCH)/corectrl/libcorectrl.so debian/corectrl/usr/bin/corectrl

override_dh_dwz:
	@echo "BYE DWZ"
